Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import nat.
Parameter invert_permut : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Parameter invert_permut_body : nat.nat -> (nat.nat -> nat.nat) -> nat.nat -> nat.nat.
Axiom axiom_invert_permut_body_S : forall (n:nat.nat), connectives.equal ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body (nat.S n)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n)))).
Definition eq_invert_permut_body_S : forall (n:nat.nat), leibniz.leibniz ((nat.nat -> nat.nat) -> nat.nat -> nat.nat) (invert_permut_body (nat.S n)) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n)))) := fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> nat.nat) -> nat.nat -> nat.nat)) (invert_permut_body (nat.S n))) (fun (f:(nat.nat -> nat.nat)) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (nat.S n) (invert_permut n f m) (nat.eqb m (f (nat.S n))))) ((axiom_invert_permut_body_S) (n)).
